# (c) cavaliba.com - home - cache.py

import copy



# -----------------------------------------
# cache
# -----------------------------------------

cache_configuration = {}
cache_aaa = {}
cache_enum = {}
cache_classname = {}
cache_classid = {}
cache_schema = {}
cache_instance_name = {}
cache_fieldschema_detail = {}

def init():
    global cache_configuration
    global cache_aaa
    global cache_enum
    global cache_classname
    global cache_classid
    global cache_schema
    global cache_instance_name
    global cache_fieldschema_detail

    cache_configuration = {}
    cache_aaa={}
    cache_enum = {}
    cache_classname = {}
    cache_classid = {}
    cache_schema = {}
    cache_instance_name = {}
    cache_fieldschema_detail = {}


# INSTANCE
def instance_key(classname, iname):
    return f"{classname}::{iname}"

def instance_get(classname, iname):
    key = f"{classname}::{iname}"
    try:
        return cache_instance_name[key]
    except:
        return None

def instance_store(classname, iname, obj):
    key = f"{classname}::{iname}"
    cache_instance_name[key] = copy.deepcopy(obj)

def instance_purge(classname, iname):
    key = f"{classname}::{iname}"
    cache_instance_name.pop(key, None)

